AutoItSetOption("MustDeclareVars",1)
global $delay,$pause,$priority,$quality,$alwaysgop15,$strictgop,$batchmode,$Fileecl,$file
global $Fileavs,$line,$aspect_ratio,$width,$height,$frame_rate_idx,$progressive,$top_first,$title
global $vmode,$cbr_brate,$vbr_brate_avg,$vbr_brate_min,$vbr_brate_max,$opv_brate_max,$q_factor
global $gop_hdr,$all_closed_gop,$intra_dc_prec,$seq_hdr,$alwaysframe,$seq_endcode
global $altdir,$targetdir,$ext,$original,$expresstype,$process,$nopathwarn
global $minimize,$autoparameters
global $i,$initialize=0
dim $firstitem=0
dim $Procoder
dim $programini
dim $originalwindow
Global $window
Global $filepcp, $encode_first, $encode_last
Global $version="EclPRO v1.00 RC1"
dim $procoderreg


AutoItSetOption("TrayIconHide",1)
AutoItSetOption("WinTitleMatchMode", 4)

;main
	;Ini reading
	$programini=stringleft(@Scriptfullpath,stringlen(@Scriptfullpath)-3) & "ini"
	$Procoder=IniRead($programini,"Options","Procoder","");
	if @Error or $Procoder="" or not FileExists($Procoder) then
		MsgBox(64,"EclPRO",$version & @CRLF & "An Ecl Loader for Canopus Procoder" & @CRLF & @CRLF & "Written by Robot1 - 2004/2005");
		MsgBox(48,$version,"Warning!" & @CRLF & "This program could simulate key inputs:" & @CRLF & _
			"CURSORS keys, HOME, END, TAB, DEL, SPACE are used." & @CRLF & _
			@CRLF & "Be sure you don't have any programs in background checking for these keys" & _
			@CRLF & "(ex. Winamp or Quintessential Player).",0)
		$Procoder=FileOpenDialog("Find Procoder","","Procoder (*.exe)",1+2)
		if @Error or $Procoder="" or not FileExists($Procoder) then
			MsgBox(16,$version & " - Error","Can't find Procoder");
			exit
		endif
		$initialize=1
		IniWrite($programini,"Options","Procoder",$Procoder);
	endif

	$delay=IniRead($programini,"Options","Delay","");
	if @Error or $delay="" then
		$delay=0
		IniWrite($programini,"Options","Delay",$delay);
	endif
	if $delay<0 then $delay=0
	AutoItSetOption("SendKeyDelay", $delay)

	$pause=IniRead($programini,"Options","Pause","");
	if @Error or $pause="" then
		$pause=20
		IniWrite($programini,"Options","Pause",$pause);
	endif

	$priority=IniRead($programini,"Options","Priority","");
	if @Error or $priority="" then
		$priority=0
		IniWrite($programini,"Options","Priority",$priority);
	endif
	$priority= $priority * 2

	$minimize=IniRead($programini,"Options","Minimize","");
	if @Error or $minimize="" then
		$minimize=0
		IniWrite($programini,"Options","Minimize",$minimize);
	endif

	$nopathwarn=IniRead($programini,"Options","NoPathWarn","")
	if @Error or $nopathwarn="" then
		$nopathwarn=0
		IniWrite($programini,"Options","NoPathWarn",$nopathwarn);
	endif

	$quality=IniRead($programini,"Quality","Quality","")
	if @Error or $quality="" then
		$quality=4
		IniWrite($programini,"Quality","Quality",$quality)
	endif

	$autoparameters=IniRead($programini,"Quality","AutoParameters","")
	if @Error or $autoparameters="" then
		$autoparameters=0
		IniWrite($programini,"Quality","AutoParameters",$autoparameters)
	endif

	$alwaysgop15=IniRead($programini,"Quality","AlwaysGOP15","")
	if @Error or $alwaysgop15="" then
		$alwaysgop15=0
		IniWrite($programini,"Quality","AlwaysGOP15",$alwaysgop15)
	endif

	$alwaysframe=IniRead($programini,"Quality","Alwaysframe","")
	if @Error or $alwaysframe="" then
		$alwaysframe=1
		IniWrite($programini,"Quality","Alwaysframe",$alwaysframe)
	endif

	$strictgop=IniRead($programini,"Debug","StrictGOPBrateControl","")
	if @Error or $strictgop="" then
		$strictgop=0
		IniWrite($programini,"Debug","StrictGOPBrateControl",$strictgop)
	endif


	;SETUP
	if $initialize=1 then
		if MsgBox(36,$version,"Do you want to manually configure ProCoder options?") = 6 then
			if MsgBox(36,$version,"Enable ""Mastering Quality""?" & @CRLF & "(better quality but slower)") = 7 then
				IniWrite($programini,"Quality","Quality","3")
			endif
			if MsgBox(36,$version,"Dynamically change encoding parameters?" & @CRLF & "(GOP Length & DC Precision based on bitrate)") = 7 then
				IniWrite($programini,"Quality","AutoParameters","0")
				if MsgBox(36,$version,"Force Max Gop Length always to 15?" & @CRLF & "(better for lower bitrates)") = 7 then
					IniWrite($programini,"Quality","AlwaysGOP15","0")
				else
					IniWrite($programini,"Quality","AlwaysGOP15","1")			
				endif
			else
				IniWrite($programini,"Quality","AutoParameters","1")			
			endif
			if MsgBox(36,$version,"Force field encoding for interlaced sources?" & @CRLF & "(should give better quality)") = 6 then
				IniWrite($programini,"Quality","Alwaysframe","0")
			endif
			if MsgBox(36,$version,"Run ProCoder minimized in batch mode?") = 6 then
				IniWrite($programini,"Options","Minimize","1")
			endif
		endif
		MsgBox(64,$version,"Setup Completed" & @CRLF & "Restart EclPro to load an .ecl in ProCoder");
		Exit
	endif


	;Init - allows only one istance in some cases, and delete temp files.
	$title=IniRead($programini,"Temp","Filename","")

	If WinExists("Canopus ProCoder") then
		if (stringinstr($Procoder,"Procoder2.exe")=0) Then 
			MsgBox(16,$version & " - Error","Only one instance is allowed" & @CRLF & "Multiple istances allowed only for ProCoder2")
			Exit ; It's already running
		else
			sleep(50*$pause)
		endif
		if stringlen($title)>0 then
			MsgBox(16,$version & " - Error","Only one instance is allowed running from the same directory")
			Exit ; It's already running
		endif
	endif

	if stringlen($title>0)	then 
		FileDelete($title)
		IniWrite($programini,"Temp","Filename","")
	endif
	

	;Parsing Commandline
	$batchmode=0;
	$Fileecl=""
	if $CmdLine[0]=0 then
		if MsgBox(36,$version & " - Main","Would you load an .ecl?")=6 then
  			$Fileecl=FileOpenDialog("Open Ecl", "", "ECL (*.ecl)",1+2)
	  		if @Error then
  				MsgBox(48,$version & " - Error","No file chosen");
				Run($Procoder)
  				exit
	  		endif
  		else
  			Run($Procoder)
	  		Exit
  		endif
	else
		for $i=1 to $CmdLine[0]
			if StringLower($CmdLine[$i])="-batch" then
				$batchmode=1;
			endif
			if StringLower($CmdLine[$i])="-ecl" and $i<$CmdLine[0] then
				$Fileecl=$CmdLine[$i+1]
			endif
		next
	endif

	if $Fileecl="" then
  	MsgBox(16,$version & " - Error","Wrong Parameters!" & @CRLF & "Usage: EclPro [-ecl file.ecl [-batch] ]");
  	Exit;
	endif



	;Reading ECL File
	$file=FileOpen($Fileecl,0);
	If $file = -1 Then
    	MsgBox(16, $version & " - Error", "Unable to open file.")
    	Exit
	EndIf
	$Fileavs=""
	while 1
		$line=FileReadLine($file)
		if @Error=-1 then
			FileClose($file);
			ExitLoop
		endif
		if stringleft($line,6)="[item]" then
			if $firstitem=0 then 
				$firstitem=1
			else
				if $fileavs<>"" then
					StartProcoder()
					if $batchmode=0 then exit
				endif
			endif
		endif
			
		if stringleft($line,5)="name=" then
			$Fileavs=stringmid($line,6,stringlen($line)-5)

		elseif stringleft($line,13)="aspect_ratio=" then
			$aspect_ratio=stringmid($line,14,stringlen($line)-13)
			#CS in target options:
				1 1:1	vga
				2 4:3
				3 16:9
				4 2.21:1 
			#CE
		elseif stringleft($line,6)="width=" then
			$width=stringmid($line,7,stringlen($line)-6)
		elseif stringleft($line,7)="height=" then
			$height=stringmid($line,8,stringlen($line)-7)
		elseif stringleft($line,15)="frame_rate_idx=" then
			$frame_rate_idx=stringmid($line,16,stringlen($line)-15)
	
		elseif stringleft($line,12)="progressive=" then
			$progressive=stringmid($line,13,stringlen($line)-12)
		elseif stringleft($line,10)="top_first=" then 
			$top_first=1-stringmid($line,11,stringlen($line)-10)
		elseif stringleft($line,12)="offset_line=" then
			$top_first=stringmid($line,13,stringlen($line)-10)
			while ($top_first>1) 
				$top_first=$top_first-2
			wend
			$top_first=1-$top_first
	;	elseif stringleft($line,6)="title=" then
	;		$title=stringmid($line,7,stringlen($line)-6)
		elseif stringleft($line,10)="vid_file0=" then
			$title=stringmid($line,11,stringlen($line)-10)
	
		elseif stringleft($line,6)="vmode=" then
			$vmode=stringmid($line,7,stringlen($line)-6)
			#CS
			vmode:
				OPV 0
				CBR 1
				VBR 2
			#CE
		elseif stringleft($line,11)="video_type=" then
			$vmode=stringmid($line,12,stringlen($line)-11)
			#CS
			vmode:
				OPV 2
				CBR 1
				VBR 4
			#CE
			if $vmode=2 then 
				$vmode=0
			elseif $vmode=4 then
				$vmode=2
			endif
		
		elseif stringleft($line,10)="cbr_brate=" then
			$cbr_brate=stringmid($line,11,stringlen($line)-10)
			if $cbr_brate<900 then $cbr_brate=900
		elseif stringleft($line,14)="vbr_brate_avg=" then
			$vbr_brate_avg=stringmid($line,15,stringlen($line)-14)
			if $vbr_brate_avg<900 then $vbr_brate_avg=900
		elseif stringleft($line,14)="vbr_brate_min=" then
			$vbr_brate_min=stringmid($line,15,stringlen($line)-14)
		elseif stringleft($line,14)="vbr_brate_max=" then
			$vbr_brate_max=stringmid($line,15,stringlen($line)-14)
			if $vbr_brate_max<900 then $vbr_brate_max=900
		elseif stringleft($line,14)="opv_brate_max=" then
			$opv_brate_max=stringmid($line,15,stringlen($line)-14)
			if $opv_brate_max<900 then $opv_brate_max=900
		elseif stringleft($line,13)="opv_q_factor=" then
			$q_factor=stringmid($line,14,stringlen($line)-13)
			$q_factor=$q_factor-1
			if $q_factor>100 then $q_factor=100
		
		elseif stringleft($line,12)="seq_endcode=" then
			$seq_endcode=stringmid($line,13,stringlen($line)-12)
	
		
		elseif stringleft($line,8)="gop_hdr=" then
			$gop_hdr=stringmid($line,9,stringlen($line)-8)
		elseif stringleft($line,15)="all_closed_gop=" then
			$all_closed_gop=stringmid($line,16,stringlen($line)-15)
		elseif stringleft($line,14)="intra_dc_prec=" then
			$intra_dc_prec=stringmid($line,15,stringlen($line)-14)
		elseif stringleft($line,8)="seq_hdr=" then
			$seq_hdr=stringmid($line,9,stringlen($line)-8)

		elseif stringleft($line,13)="encode_first=" then
			$encode_first=stringmid($line,14,stringlen($line)-13)
		elseif stringleft($line,12)="encode_last=" then
			$encode_last=stringmid($line,13,stringlen($line)-12)

		endif
	wend
	if $encode_last=0 then
		;nothing to encode. Create a o bytes .m2v file
		$file=FileOpen($title, 2)
		FileClose($file)
		exit
	endif
	
	
	if $alwaysgop15=1 then
		$gop_hdr=15;
	endif

	if $autoparameters=1 and $vmode>0 and $all_closed_gop=0 then
		dim $brate;
		if $vmode=1 then 
			$brate=$cbr_brate
		else 
			$brate=$vbr_brate_avg
		endif
		if $progressive=0 then $brate=$brate-150
		if $brate<1800 then
			$gop_hdr=15
			$intra_dc_prec=0
		elseif $brate <2500 then
			$gop_hdr=15
			$intra_dc_prec=1
		elseif $brate <3500 then
			$gop_hdr=15
			$intra_dc_prec=2
		else
			if $alwaysgop15=0 then
				$gop_hdr=12
			endif
			$intra_dc_prec=2
		endif
	endif
	

	StartProcoder()
	exit
;end main


Func Automationerror($phase)
	WinSetState($window,"",@SW_SHOW)
	BlockInput(0)
	MsgBox(16,"Error","Automation error: " & $phase)
	Exit
endfunc



Func StartProcoder()
	if $Fileavs="" then
		MsgBox(16,$version & " - Error","Wrong .ecl format");
		return
	endif
	If not FileExists($Fileavs) Then
    	MsgBox(16, $version & " - Error", "Missing source")
    	return
	EndIf

	if not stringinstr($title,"\") then
		MsgBox(16,$version & " - Error","Wrong output filename in .ecl" & @CRLF & "Full path needed!")
		return
	endif
	$original=$title
	$targetdir=stringleft($title,stringinstr($title,"\",0,-1) -1 ) ;Without backslash
	if stringinstr($title,".",0,-1) <> 0 then
		$ext=stringright($title,stringlen($title)-stringinstr($title,".",0,-1)+1)
	else
		$ext=""
	endif
	$title=stringmid($title,stringinstr($title,"\",0,-1)+1,stringlen($title)-stringlen($ext)-stringinstr($title,"\",0,-1))


;Ready to Run ProCoder
	if stringinstr($Procoder,"Procoder2.exe") <>0 then 
		$window="Canopus ProCoder 2"
		$procoderreg=RegRead("HKEY_CURRENT_USER\SOFTWARE\Canopus\ProCoder 2\App","Setup")
		if stringlen($procoderreg) <>5715 then
			if stringmid($procoderreg,5713,2)="01" then
				$procoderreg=stringleft($procoderreg,5712) & "00" & stringright($procoderreg,stringlen($procoderreg)-5714)
				RegWrite("HKEY_CURRENT_USER\SOFTWARE\Canopus\ProCoder 2\App","Setup","REG_BINARY",$procoderreg)
			endif
		endif		
	elseif stringinstr($Procoder,"PrcExprs.exe") then
		$window="Canopus ProCoder Express"
	elseif stringinstr($Procoder,"PceEdius.exe") then
		$window="Canopus ProCoder Express"
	elseif stringinstr($Procoder,"Procoder.exe") then
		$window="Canopus ProCoder"
		if $batchmode=1 then $Procoder=$Procoder & " /Shutdown"
		RegWrite("HKEY_LOCAL_MACHINE\SOFTWARE\CANOPUS\ProCoder\AlertBox", "2pass_no_split", "REG_DWORD","0x00000000" )
		RegWrite("HKEY_LOCAL_MACHINE\SOFTWARE\CANOPUS\ProCoder\AlertBox", "mastering_is_slow", "REG_DWORD", "0x00000000")	
	else
		MsgBox(16,$version & " - Error","Unsupported ProCoder version");
		IniWrite($programini,"Options","Procoder","");
		return
	endif


	$altdir=0
	if ($ext<> ".m2v" or $seq_endcode=0) and $batchmode=1 then 
		$altdir=1
	elseif $window="Canopus ProCoder" then 
		$altdir=1
	elseif stringinstr($title,".") then
		$altdir=1
		while(stringinstr($title,".")) 
			$title=stringleft($title,stringinstr($title,".")-1) & stringright($title,stringlen($title)-stringinstr($title,"."))
		wend
		MsgBox(16,"",$title)
	endif
	if $altdir=1 then 
		$targetdir=stringleft($targetdir,2)
		;if $batchmode=1 then $title="ECLPro-temp"	uso stringhe diverse, ma memorizzo e cancello in caso di ripartenza
		if $batchmode=1 then IniWrite($programini,"Temp","Filename",$targetdir & "\" & $title);

	endif
	FileDelete($targetdir & "\" & $title)
	$originalwindow=WinGetHandle("")

	if $window = "Canopus ProCoder Express" then
;for Procoder Express!

		if stringinstr($Procoder,"Edius") then 
			$expresstype="ProCoder Express for EDIUS"
		else
			$expresstype="ProCoder Express"
		endif
		RegWrite("HKEY_CURRENT_USER\SOFTWARE\CANOPUS\" & $expresstype & "\Pages\LoadSourcePage", "SOURCESETTING", "REG_DWORD","0x00000001" )
		RegWrite("HKEY_CURRENT_USER\SOFTWARE\CANOPUS\" & $expresstype & "\Pages\SourceCroppingPage", "CropMethodSelection", "REG_DWORD","0x00000401" )
		RegWrite("HKEY_CURRENT_USER\SOFTWARE\CANOPUS\" & $expresstype & "\Pages\TargetFileNamePage", "TargetFolder", "REG_SZ", $targetdir & "\")
		RegWrite("HKEY_CURRENT_USER\SOFTWARE\CANOPUS\" & $expresstype & "\Pages\DispatchHistoryPage", "History", "REG_DWORD", "0x00000443")	;1092 dec 0x00000444 esadec
		RegWrite("HKEY_CURRENT_USER\SOFTWARE\CANOPUS\" & $expresstype & "\Pages\CW_StartPageGeneric", "CtrlSelectedRadio102-109", "REG_DWORD", "0x00000068")	;104 dec 0x00000068 esadec
		RegWrite("HKEY_CURRENT_USER\SOFTWARE\CANOPUS\" & $expresstype & "\Pages\TargetFileNamePage", "CHOOSETARGETBASENAME", "REG_DWORD", "0x00000000")	
		RegWrite("HKEY_CURRENT_USER\SOFTWARE\CANOPUS\" & $expresstype & "\Pages\TargetFileNamePage", "TARGETOVERWRITE", "REG_DWORD", "0x00000001")	
		StartEx()
		
	elseif $window="Canopus ProCoder 2" then
		StartNew()

	else
		StartLegacy()

	endif
endfunc


func StartNew()
	$filepcp = FileOpen($fileecl & ".pcp", 2)
	If $filepcp = -1 Then
		MsgBox(16,$version & " - Error","Unable to open target file.");
    	Exit
	EndIf
	filewrite($filepcp,"<?xml version=""1.0""?>" & @CRLF);
	filewrite($filepcp,"<cnpsXML>" & @CRLF );
	
	CreateXML()


	$Procoder=$Procoder & " """ & $fileecl &".pcp""" ;
	if($batchmode=1) then $Procoder = $Procoder & " /Start /CloseApp";
	$process=Run($Procoder)
	ProcessWait($process,5*$pause)
	if not ProcessExists($process) then 
		MsgBox(16,$version & " - Error","Can't launch ProCoder")
		exit
	endif

	
	ProcessSetPriority ($process,$priority)

	if($batchmode=1 and $minimize=1) then
		winactivate("handle=" & $originalwindow)
		WinWait($window,"",10*$pause);
		WinSetState($window,"",@SW_MINIMIZE)
	endif

	while ProcessExists($process)
		sleep(2000)
	wend

	if $batchmode=1 then
		filedelete($fileecl & ".pcp")
		FinalCheck()
	endif

endfunc



func StartEx()
	dim $targetexpress;
	
;PROCODER EXPRESS
	$Procoder=$Procoder & " /Targetdir:""" & $targetdir & """ " & """" & $Fileavs & """";
	$process=Run($Procoder)
	
	$targetexpress=@AppDataDir & "\Canopus\" & $expresstype & "\History\ECLPro.xml"
	
	filedelete($targetexpress)
	
	$filepcp = FileOpen($targetexpress, 2)
	If $filepcp = -1 Then
		MsgBox(16,$version & " - Error","Unable to open target file.");
    	Exit
	EndIf

	
	filewrite($filepcp,"<?xml version=""1.0"" encoding=""UTF-8""?>" & @CRLF);
	filewrite($filepcp,"<cnpsXML>" & @CRLF );
	filewrite($filepcp,"<Header Name=""DVD-RB Target (01-01-25,00:00:00)"" Version=""" & $expresstype & """/>" );

	CreateXML()


	ProcessWait($process,5*$pause)
	ProcessSetPriority ($process,4)
	WinWait($window,"", $pause)
	BlockInput(1)
	WinSetState($window,"",@SW_HIDE)

	if not WinExists($window) then 
		BlockInput(0)
		MsgBox(16,$version & " - Error","Can't launch ProCoder")
		exit
	endif

	WinActivate($window)
	WinWaitActive($window,"",$pause)
	if not WinActive($window) then 
		Automationerror("Set source data")
	endif

;Go to advanced settings
	WinSetState($window,"",@SW_HIDE)
	controlFocus($window,"","&Next");
	ControlClick($window,"","&Next");
	WinActivate($window)
	controlFocus($window,"","&Next");
	ControlClick($window,"","&Next");
	WinActivate($window)
	controlfocus($window,"","Select Settings");	
	ControlClick ($window,"", "Select Settings" )
	WinWait("Config","",$pause)
	if not WinExists("Config") then 
		Automationerror("Advanced config - source")
	endif
	controlfocus("Config","","ComboBox1");

	;Set Progressive - Interlaced
	send("{HOME}")
	if($progressive<>1) then
		Send("{RIGHT}")
		if($top_first=1) then Send("{RIGHT}")
	endif
				
	controlFocus("Config","","...");
	ControlClick("Config","","...");
	WinWait("Aspect Ratio Configuration","",$pause)
	
	;Select Aspect Ratio
	if not WinExists("Aspect Ratio Configuration") then 
		Automationerror("Select aspect ratio")
	endif
	WinActivate("Aspect Ratio Configuration")
	controlFocus("Aspect Ratio Configuration","","CUIComboBox2");
	send("{END}")
	if $aspect_ratio=2 then
		send("{LEFT}")
	elseif $aspect_ratio=3 then
		;send("{RIGHT 2}")
	else
		send("+{TAB}")
		send("1")
		send("+{TAB}")
		if $aspect_ratio=1 then
			send("1")
		else
			send("2.21")
		endif
	endif
		
	send(@CR)
	WinActivate("Config")
	WinWaitActive("Config","",$pause)
	if not WinActive("Config") then 
		Automationerror("Ready to Add Target")
	endif
	send("c")
	
	WinActivate($window)
	controlFocus($window,"","&Next");
	ControlClick($window,"","&Next");
	
	WinActivate($window)
	controlFocus($window,"","Select a previous history setting :");
	ControlClick($window,"","Select a previous history setting :");
				
	controlFocus($window,"","&Next");
	ControlClick($window,"","&Next");

	WinActivate($window)
	controlFocus($window,"","&Next");
	ControlClick($window,"","&Next");
	
	WinActivate($window)
	
	if $batchmode=1 then
		;WinWait($window,"",10*$pause);
		;Send("e")
		controlFocus($window,"","&Next");
		ControlClick($window,"","&Next");
		
		BlockInput(0)
		ProcessSetPriority ($process,$priority)
		if ($minimize=1) then
			WinSetState($window,"",@SW_MINIMIZE)
		else
			WinSetState($window,"",@SW_SHOW)
		endif
		winactivate("handle=" & $originalwindow)

		while not WinExists($window,"Conversion Finished.")
			sleep(2000)
		wend
	
		processclose($process)
		ProcessWaitClose($process,2)
		If ProcessExists($process) then ProcessClose($process)
		
		FinalCheck()
		filedelete($targetexpress)


	else
		BlockInput(0)
		WinSetState($window,"",@SW_SHOW)
		ProcessSetPriority ($process,$priority)
	endif	

	return

endfunc

func CreateXML(); this is the XML used by ProCoder 2 and ProCoder Express
	dim $fps;
	dim $newfileavs, $newtargetdir;
	
	$newtargetdir="";
	$newfileavs="";
	
	for $i=1 to stringlen($fileavs)
	  if stringmid($fileavs,$i,1)="&" then
	  	$newfileavs=$newfileavs & "&amp;"
	  elseif asc(stringmid($fileavs,$i,1)) <=128 then
	  	$newfileavs=$newfileavs & stringmid($fileavs,$i,1)
	  else
	    $newfileavs=$newfileavs & "&#" & asc(stringmid($fileavs,$i,1)) & ";"
	  endif
	next

	for $i=1 to stringlen($targetdir)
	  if stringmid($targetdir,$i,1)="&" then
	  	$newtargetdir=$newtargetdir & "&amp;"
	  elseif asc(stringmid($targetdir,$i,1)) <=128 then
	  	$newtargetdir=$newtargetdir & stringmid($targetdir,$i,1)
	  else
	    $newtargetdir=$newtargetdir & "&#" & asc(stringmid($targetdir,$i,1)) & ";"
	  endif
	next

	if $frame_rate_idx=1 then
		$fps=24000000/1001001;
	elseif $frame_rate_idx=2 then
		$fps=24;
	elseif $frame_rate_idx=3 then
		$fps=25
	elseif $frame_rate_idx=4 then
		$fps=30000000/1001001;
	elseif $frame_rate_idx=5 then
		$fps=30;
	endif

	filewrite($filepcp,"<Sources><Module_0 Inpoint.QWD=""" & int($encode_first *27000/$fps) & "000""");
	filewrite($filepcp," Outpoint.QWD=""" & int($encode_last * 27000/$fps) & "000""");
	filewrite($filepcp," MultiSource.DWD=""1""><ModuleData><StreamTypeTable StreamSelector_0.DWD=""0"" StreamPtr_0.DWD=""0"" StreamSelector_1.DWD=""2"" StreamPtr_1.DWD=""0""/><SourceModules><MultiSrcModule_0 MultiSource.DWD=""0"" Filename=""");
	filewrite($filepcp,$newfileavs & """><ModuleData FrameMode.DWD=""");
	if $progressive=1 then 
		filewrite($filepcp,"0");
	else 
		filewrite($filepcp,1+$top_first);		0 prog 	1 BF  2 TF
	endif
	filewrite($filepcp,""" AspectRatio.BIN=""");
	if $aspect_ratio=1 then
		filewrite($filepcp,"AQAAAAEAAAA");	PAL D1 - DON'T CARE OF OTHERS
	elseif $aspect_ratio=2 then
		if $frame_rate_idx=3 then
			if $width=720 then
				filewrite($filepcp,"EAAAAA8AAAA");	PAL D1 4/3
			elseif $width=704 then
				filewrite($filepcp,"DAAAAAsAAAA");  PAL D1 704 4/3
			elseif $width=480 then
				filewrite($filepcp,"CAAAAAUAAAA");	PAL SVCD 4/3			
			else
				filewrite($filepcp,"GAAAAAsAAAA");	PAL HD1 4/3	
			endif
		else
			if $width=720 then
				filewrite($filepcp,"CQAAAAoAAAA");	NTSC D1 4/3
			elseif $width=704 then
				filewrite($filepcp,"CgAAAAsAAAA");  NTSC D1 704 4/3
			elseif $width=480 then
				filewrite($filepcp,"BAAAAAMAAAA");	NTSC SVCD 4/3			
			else
				filewrite($filepcp,"FAAAAAsAAAA");	NTSC HD1 4/3	
			endif
		endif
	elseif $aspect_ratio=3 then
		if $frame_rate_idx=3 then
			if $width=720 then
				filewrite($filepcp,"QAAAAC0AAAA");	PAL D1 16/9
			elseif $width=704 then
				filewrite($filepcp,"EAAAAAsAAAA");  PAL D1 704 16/9
			elseif $width=480 then
				filewrite($filepcp,"IAAAAA8AAAA");	PAL SVCD 16/9			
			else
				filewrite($filepcp,"IAAAAAsAAAA");	PAL HD1 16/9
			endif
		else
			if $width=720 then
				filewrite($filepcp,"BgAAAAUAAAA");	NTSC D1 16/9
			elseif $width=704 then
				filewrite($filepcp,"KAAAACEAAAA");  NTSC D1 704 16/9
			elseif $width=480 then
				filewrite($filepcp,"EAAAAAkAAAA");	NTSC SVCD 16/9			
			else
				filewrite($filepcp,"UAAAACEAAAA");	NTSC HD1 16/9 
			endif
		endif
	else 
		filewrite($filepcp,"AgAAAAEAAAA");	PAL D1 - DON'T CARE OF OTHERS
	endif
	filewrite($filepcp,"=""/></MultiSrcModule_0></SourceModules></ModuleData><Filter_0/><Filter_1/></Module_0></Sources><Variable/><Destinations><Module_0 ModuleGUID=");
	filewrite($filepcp,"""{A7264AEF-FF57-42E0-BBAD-CCF546CD515F}"" PresetGUID=""{A7264AEF-FF57-42E0-BBAD-CCF546CD515F}""><ModuleData CML_P_BaseFileName=""");
	filewrite($filepcp,$title & """ CML_P_Path=""" & $newtargetdir & """ DestFileUseSource.DWD=""1"" CML_P_SplitSelection.DWD=""0"" CML_P_SplitTime.DWD=""10"" QControl.DWD=""1"" UserMediaSize.BIN=""AJQ1dwAAAAA="" stream_format.DWD=""5"" vob_marker_point.DWD=""1"" vob_chapter_method.DWD=""0"" vob_chapter_interval.DWD=""15"" use_dvd_repeat_mode.DWD=""0"" stream_type.DWD=""3"" video_pid.DWD=""4096"" video_standard.DWD=""0"" CML_V_SizeX.DWD=""");
	filewrite($filepcp,$width & """ CML_V_SizeY.DWD=""" & $height & """ frame_rate_code.DWD=""" & $frame_rate_idx & """ interlace_mode.DWD=""");
	if $progressive=1 then 
		filewrite($filepcp,"0");
	else 
		filewrite($filepcp,1+$top_first);		0 prog 	1 BF  2 TF
	endif
	filewrite($filepcp,""" aspect_ratio_code.DWD=""" & $aspect_ratio & """ quality_code.DWD=""");
	if $quality=4 then 
		filewrite($filepcp,"8");
	elseif $quality=3 then
		filewrite($filepcp,"7");
	elseif $quality=2 then
		filewrite($filepcp,"2");
	else
		filewrite($filepcp,"0");
	endif
	filewrite($filepcp,""" bitrate_mode.DWD=""");
	if $vmode=0 then
		filewrite($filepcp,"0");
	elseif $vmode=1 then
		filewrite($filepcp,"2");
	else
		filewrite($filepcp,"1");
	endif
	filewrite($filepcp,""" number_of_passes.DWD=""");
	if $vmode=2 then 
		filewrite($filepcp,"2");
	else
		filewrite($filepcp,"1");
	endif
	filewrite($filepcp,""" bitrate.DWD=""");
	if $vmode=1 then
		filewrite($filepcp,$cbr_brate);
	else
		filewrite($filepcp,$vbr_brate_avg);
	endif
	filewrite($filepcp,""" max_bitrate.DWD=""");
	if $vmode=0 then
		filewrite($filepcp,$opv_brate_max);
	else
		filewrite($filepcp,$vbr_brate_max);
	endif
	filewrite($filepcp,""" min_bitrate.DWD=""" & $vbr_brate_min & """ ip_quant.DBL=""" & (100-$q_factor)/100);
	if $q_factor <>100 and $q_factor <> 0 then
		filewrite($filepcp,"0000");
	else
		filewrite($filepcp,".000000");
	endif
	filewrite($filepcp,""" reservoir_buffer_size.DWD=""1024"" expense_buffer_size.DWD=""1024"" profile_level.DWD=""3"" use_sh_each_gop.DWD=""" & $seq_hdr);
	filewrite($filepcp,""" vbv_buffer_size.DWD=""224"" max_gop_frames.DWD=""");
	filewrite($filepcp,$gop_hdr);
	filewrite($filepcp,""" max_ip_distance.DWD=""-1"" picture_structure.DWD=""");
	if ($progressive=0 and $alwaysframe=0) then
		filewrite($filepcp,"0")
	else 
		filewrite($filepcp,"1")
	endif
	filewrite($filepcp,""" use_closed_gop.DWD=""" & $all_closed_gop & """ chroma_format.DWD=""0"" dc_precision.DWD=""" & $intra_dc_prec +8);
	filewrite($filepcp,""" use_strict_gop_bitrate.DWD=""" & $strictgop & """ use_dvd_compatible.DWD=""1"" UsedStreamAudio.DWD=""2""");
	filewrite($filepcp," audio_stream_type.DWD=""1"" audio_pid.DWD=""4097"" audio_bitrate.DWD=""224000"" CML_A_SampleRate.DWD=""48000"" audio_channels.DWD=""0"" pcm_channels.DWD=""0"" pcm_pid.DWD=""4098"" CML_A_SampleSize.DWD=""16"" audio_has_error_protection.DWD=""1"" audio_has_copyright_bit.DWD=""0"" audio_has_original_bit.DWD=""0"" audio_emphasis.DWD=""0"" pcm_emphasis.DWD=""0"" use_fixed_mux_rate.DWD=""0"" use_stream_audio.DWD=""2"" ");
	filewrite($filepcp,"CML_P_ForcedSplitMinutes.DWD=""0""/><Filter_0/><Filter_1/></Module_0></Destinations><ProjectSettings Stitching.DWD=""0""/></cnpsXML>");
	FileClose($filepcp)
endfunc


Func StartLegacy()
;Running ProCoder
	$Procoder=$Procoder & " /Targetdir:""" & $targetdir & """ " & """" & $Fileavs & """";
	$process=Run($Procoder)
	ProcessWait($process,5*$pause)
	ProcessSetPriority ($process,4)
	WinWait($window,"", $pause)
	WinSetState($window,"",@SW_HIDE)

	if not WinExists($window) then 
		BlockInput(0)
		MsgBox(16,$version & " - Error","Can't launch ProCoder")
		exit
	endif

	BlockInput(1)
	WinActivate($window)
	WinWaitActive($window,"",$pause)
	if not WinActive($window) then 
		Automationerror("Set source data")
	endif


;Set Parameters

;PROCODER 1.5	
;Set Progressive - Interlaced
	WinActivate($window)
	WinWaitActive($window,"",$pause)
	WinSetState($window,"",@SW_HIDE)

	Send("{TAB 6}{DOWN 5}")

	
	Send("{HOME}")
	if($progressive<>1) then
		Send("{RIGHT}")
		if($top_first=1) then Send("{RIGHT}")
	endif

	WinSetState($window,"",@SW_HIDE)
	WinActivate($window)
	Send("{DOWN}{SPACE}")
	WinWait("Aspect Ratio Configuration","",$pause)

	if not WinExists("Aspect Ratio Configuration") then 
		Automationerror("Select aspect ratio")
	endif
	WinActivate("Aspect Ratio Configuration")
	send("+{TAB}")
	send("{END}")
	if $aspect_ratio=2 then
		send("{LEFT}")
	elseif $aspect_ratio=3 then
		;send("{RIGHT 2}")
	else
		send("+{TAB}")
		send("1")
		send("+{TAB}")
		if $aspect_ratio=1 then
			send("1")
		else
			send("2.21")
		endif
	endif
	send(@CR)
	WinActivate($window)
	WinWaitActive($window,"",$pause)
	if not WinActive($window) then 
		Automationerror("Ready to Add Target")
	endif


	;Add target - MPEG

	Send("^t")
	Sleep($pause)
	WinActivate($window)
	Send("{SPACE}")

	WinWait("Add Target","",$pause/10)
	WinActivate("Add Target")
	if not WinExists("Add Target") then
		Automationerror("Add Target")
	endif
	AutoItSetOption("Mousecoordmode",0)
	if not WinActive("Add Target") then
		WinActivate("Add Target")
		WinWaitActive("Add Target","",$pause/10)
	endif
	Controlfocus("Add Target","","Cnps.ChameleonTab.11")
	;ControlClick("Add Target","","Cnps.ChameleonTab.11")
	MouseClick("left",40,42,2,0)
	Controlfocus("Add Target","","CUIListBox1")
	Send("{HOME}{DOWN 2}" & @CR)
	Sleep($pause)
	WinActivate($window)

	;Go to advanced
	send("+{TAB}")
	send("+{TAB}")
	send("+{TAB}")
	send("d")
	Sleep(10*$pause)


	;Base name
	Send("{TAB 4}{DOWN}")
	send($title)


	;Stream type
	send("{DOWN 9}{END}{LEFT 2}")

	;Set width, heigth, framerate
	WinActivate($window)
	send("{DOWN}{DEL 4}")
	send($width)
	send("{DOWN}{DEL 4}")
	send($height)
	send("{DOWN}{HOME}")
	for $i=1 to ($frame_rate_idx - 1)
		send("{RIGHT}")
	next

	;Set Progressive - Interlaced
	send("{DOWN}{HOME}")
	if($progressive<>1) then
		Send("{RIGHT}")
		if($top_first<>1) then Send("{RIGHT}")	;Odd! it's different from source!
	endif

	;Set AR
	send("{DOWN}{SPACE}")
	
	WinWait("Aspect Ratio Configuration","",$pause)

	if not WinExists("Aspect Ratio Configuration") then 
		Automationerror("Select target aspect ratio")
	endif
	WinActivate("Aspect Ratio Configuration")
	send("+{TAB}")
	send("{END}")
	if $aspect_ratio=2 then
		send("{LEFT}")
	elseif $aspect_ratio=3 then
		;send("{RIGHT 2}")
	else
		send("+{TAB}")
		send("1")
		send("+{TAB}")
		if $aspect_ratio=1 then
			send("1")
		else
			send("2.21")
		endif
	endif
	send(@CR)
	WinActivate($window)
	WinWaitActive($window,"",$pause)
	if not WinActive($window) then 
		Automationerror("Ready to Quality mode")
	endif

	;Set Quality
	send("{DOWN}{HOME}")
	for $i=1 to $quality -1
		send("{RIGHT}")
	next

	;Set Mode			;CQ mode isn't supported 
	send("{DOWN}{END}")
	if $vmode=1 THEN send("{LEFT 2}")

	;Set bitrate
	WinActivate($window)
	send("{DOWN}{DEL 4}")

	if $vmode <2 then	;CBR
		send($cbr_brate)
		send("{DOWN}")
	else
		send($vbr_brate_avg)
		send("{DOWN}{DEL 4}")
		send($vbr_brate_max)
	endif

	;Gop size - sequence header and field/frame encoding
	send("{DOWN}")
	if ($all_closed_gop=1) then send("{SPACE}")	;To check
	send("{DOWN}")
	if ($gop_hdr <>15) then 
		send("{DEL 2}")
		send($gop_hdr)
	endif
	send("{DOWN 2}")
	if $seq_hdr<>1 then send("{SPACE}")
	send("{DOWN 2}{SPACE}")
	send("{DOWN 3}")
	if ($progressive=0 and $alwaysframe=0) then
		send("{END}")
	endif
	
	;DC precision
	send("{DOWN}{END}")
	for $i=2 to $intra_dc_prec+1 STEP -1
		send("{LEFT}")
	next

	;Audio
	send("{DOWN 2}{HOME}") ;Lowest quality audio

	
;Convert
	if $batchmode=1 then
		WinActivate($window)
		Send("^e")
		sleep($pause)
		WinActivate($window)
		send("{SPACE}")
		sleep($pause)

		WinWaitActive("Target File Warning", "", $pause/10)
		if WinExists("Target File Warning") then
			WinActivate("Target File Warging")
			send("o")
			send(@CR)
		endif
		BlockInput(0)
		ProcessSetPriority ($process,$priority)
		if ($minimize=1) then
			WinSetState($window,"",@SW_MINIMIZE)
		else
			WinSetState($window,"",@SW_SHOW)
		endif

		
		winactivate("handle=" & $originalwindow)
	
		;Alternative code!
		while WinExists($window)
			sleep(2000)
		wend
		ProcessWaitClose($process,2)
		If ProcessExists($process) then ProcessClose($process)
	
		FinalCheck()	
	
	else
		ProcessSetPriority ($process,$priority)
		BlockInput(0)
		WinSetState($window,"",@SW_SHOW)
		if $altdir=1 and $nopathwarn <> 1 then
			MsgBox(48,$version,"Warning, target path not correctly set")
		endif
;		if $seq_endcode=0 and $nopathwarn <> 1 then
;			MsgBox(48,$version,"Warning, seq_endcode=0 ignored")
;		endif
	endif
endfunc


Func FinalCheck()
	if $altdir=1 and $original <> ($targetdir & "\" & $title & ".m2v") then
		filedelete($original)
		if $seq_endcode=1 then
			filemove($targetdir & "\" & $title & ".m2v", $original)
			IniWrite($programini,"Temp","Filename","")	
		else
			MyFileCopy($targetdir & "\" & $title & ".m2v", $original)
		endif
		if $window="Canopus ProCoder" then
			filedelete($targetdir & "\" & $title & ".m2a")
		endif
	endif
endfunc

Func MyFileCopy($from, $to)
	if not FileExists (@SCRIPTDIR & "\rmseq.exe" ) then
		MsgBox(16,$version & " - Error","Can't find rmseq.exe" & @CRLF & "Please, copy it to the " & @SCRIPTDIR & " directory, then click OK");
	endif
	runwait("rmseq.exe " & """" & $from & """ """ & $to & """",@SCRIPTDIR, @SW_HIDE);
	filedelete($from)
	IniWrite($programini,"Temp","Filename","")
EndFunc
